{      Pascal
 Chephes, www.netlib.org\chephes ( 1.6 ,  - )
         
T., M. "  ...", ,   
( )       .
   Chehes     
     1e-10.
                                                      PAV.
}


unit ExpLib;
interface
uses SysUtils, Math, Dialogs;
const
 MathEps=1.1102230246251565E-16;     // 2**-53}
 MaxLog=7.0978271289338399E2;        // log(2**1024)}
 MinLog = -7.08396418532264106224E2; // log(2**-1022}
 Ln2 =6.9314718055994531E-1;         // log(2)}
 pio4  =0.7853981633974483e0;        // Pi/4}
 tpi   =0.6366197723675813e0;        // 2/Pi
 Sqrt2=1.41421356237309504880;       // sqrt(2)}
 Infinity=MaxDouble;

function Erf(Arg:double):double;   //  
//                           x
//                            -
//                 2         | |          2
//   erf(x)  =  --------     |    exp( - t  ) dt.
//              sqrt(pi)   | |
//                          -
//                           0
//
//     0<=Arg<9

function Erfc(Arg:double):double;  //   
//                                        inf.
//                                         -
//                              2         | |          2
//   erfc(x)= 1 - erf(x)  =  --------     |    exp( - t  ) dt
//                           sqrt(pi)   | |
//                                       -
//                            x
// 0<=Arg<9

function J0(Arg:Double):Double;    //    
// 0<arg<\inf

function Y0(Arg:Double):Double;    //      
// 0<arg<\inf

function J1(Arg:Double):Double;    //    
// 0<arg<\inf

function Y1(Arg:Double):Double;    //      
// 0<arg<\inf

function Gamma(X:Double):Double;      //  
// |arg|<34

function LnGam(X:Double):Double;      //    
// |arg|<2.55e305

function IGamC(a, x:Double):Double;   //     
//
//                                              inf.
//                                                -
//                                       1       | |  -t  a-1
//  igamc(a,x)   =   1 - igam(a,x) =   -----     |   e   t   dt.
//                                      ()   | |
//                                              -
//                                               x
// 0<x<100, 0<a<100

function IGam(a, x:Double):Double;    //    
//                           x
//                           -
//                  1       | |  -t  a-1
//  igam(a,x) =   -----     |   e   t   dt.
//                 ()   | |
//                         -
//                         0
// 0<x<100, 0<a<100

function IGamI(a:Double; y0:Double):Double;//    
//0<a<10000, 0<y0<0.5

Function GDtrC(a:Double; b:Double; x:Double):Double; //  
//                              inf
//                      b        -
//                     a        | |  b-1  -at
//  GDtrC(a,b,x) =   -----      |   t    e   dt.
//                    (b)    | |
//                             -
//                             x

function GDtr(a:Double; b:Double; x:Double):Double;  // 
//                              x
//                      b        -
//                     a        | |  b-1  -at
//   GDtr(a,b,x) =   -----      |   t    e   dt.
//                    (b)    | |
//                             -
//                             0

Function NDtrI(y0:Double):Double; {  }
Function NDtr(x:Double):Double;   { () }
//
//                            x
//                             -
//                   1        | |          2
//    ndtr(x)  = ---------    |    exp( - t /2 ) dt
//               sqrt(2pi)  | |
//                           -
//                          -inf.
//
//-13<x<0

function StDtr(k, t:Double):Double;  //  
//k -   , t -  
function StDtrI(k, p:Double):Double; //   

function PDtr(k, m:Double):Double;  //  
// PDtr( k, m ) = IGamC( k+1, m )
function PDtrC(k, m:Double):Double; //   
//PDtrC( k, m ) = IGam( k+1, m )
function PDtrI(k, y:Double):Double; //   

function IncBet(aa, bb, xx:Double):Double; //    
//                                x
//                               -
//                  (a+b)      | |  a-1     b-1
// IncBet(a,b,c)= -----------   |   t   (1-t)   dt.
//                 () (b)  | |
//                             -
//                              0
// 0<a,b<10000  0<x<1

function IncBI(aa, bb, yy0:Double):Double; //     
//0<a,b<1000  0<y<1

function BtDtr(a:Double; b:Double; x:Double):Double;//  
//  IncBet(a, b, x)

function ChDtrC(df:Double; x:Double):Double; //  - 
//ChdtrC( v, x ) = IGamC( v/2.0, x/2.0 )
function ChDtr(df:Double; x:Double):Double;  // - 
//ChDtr( v, x ) = IGam( v/2.0, x/2.0 )
function ChDtrI(df:Double; y:Double):Double; //  - 

function FDtrI(a, b, y:Double):Double;       //   F 
function FDtr(a, b, x:Double):Double;        // F 
//0<x<5, 0<a,b<10000
function FDtrC(a, b, x:Double):Double;       //  F 

function Expm1(x:Double):Double;   //Exp(x)-1  
function osm1(x:Double):Double;   //Cos(x)-1  

type
 EFuncLib = class(Exception);
 TTypeError=(
        Domain,         //     
        Sing,           //     ()
        Overflow,       // 
        Underflow,      // 
        TLoss,          //  
        PLoss);         //  
procedure MathError(TypeError:TTypeError; NameFunc:string);


implementation
procedure MathError(TypeError:TTypeError;
                    NameFunc:string);
var S:string;
begin
 case TypeError of
  Domain   :S:=' '+NameFunc+'   ';
  Sing     :S:=' '+NameFunc+'    ()';
  Overflow :S:=NameFunc+' -  (overflow)';
  Underflow:S:=NameFunc+' -  (underflow) ';
  TLoss,PLoss: S:=NameFunc+' -   ';
 end;
 raise EFuncLib.Create(S);
end;

function PolEvl(X: Extended; const Coefficients: array of Double): Extended;
{ Horner's method }
var
  I: Integer;
begin
  Result:=Coefficients[Low(Coefficients)];
  for I := Low(Coefficients)+1 to High(Coefficients) do
    Result := Result*X+Coefficients[I];
end;

function P1Evl(X: Extended; const Coefficients: array of Double): Extended;
{ Horner's method }
var
  I: Integer;
begin
  Result:=X+Coefficients[Low(Coefficients)];
  for I := Low(Coefficients)+1 to High(Coefficients) do
    Result := Result*X+Coefficients[I];
end;

{Coefficients for large x
 are #5667 from Hart & Cheney (18.72D).}

function Erf(Arg:double):double;
const
 torp=1.1283791670955125738961589031;
 p1:array[0..6] of double =
 (0.804373630960840172832162e5, 0.740407142710151470082064e4,
  0.301782788536507577809226e4, 0.380140318123903008244444e2,
  0.143383842191748205576712e2, 0.288805137207594084924010e0,
  0.007547728033418631287834e0);

 q1:array[0..6] of double =
 (0.804373630960840172826266e5, 0.342165257924628539769006e5,
  0.637960017324428279487120e4, 0.658070155459240506326937e3,
  0.380190713951939403753468e2, 0.100000000000000000000000e1,
  0.0);

var ArgSq, Sign:double;
begin
 sign:=1;
 if arg<0 then begin arg:=-arg; sign:=-1; end;
 if arg<0.5 then
  begin
   argsq:=arg*arg;
   Result:=sign*torp*arg*Poly(argsq, P1)/Poly(argsq, Q1); Exit;
  end;
 if Arg>=10 then begin Result:=sign; Exit; end;
 Result:=Sign*(1.0-erfc(arg));
end;

function Erfc(Arg:double):double;
const
 p2:array[0..8] of double =
 (0.18263348842295112592168999e4,  0.28980293292167655611275846e4,
  0.2320439590251635247384768711e4,0.1143262070703886173606073338e4,
  0.3685196154710010637133875746e3,0.7708161730368428609781633646e2,
  0.9675807882987265400604202961e1,0.5641877825507397413087057563e0,
  0.0);

 q2:array[0..8] of double =
  (0.18263348842295112595576438e4, 0.495882756472114071495438422e4,
   0.60895424232724435504633068e4, 0.4429612803883682726711528526e4,
   0.2094384367789539593790281779e4,0.6617361207107653469211984771e3,
   0.1371255960500622202878443578e3,0.1714980943627607849376131193e2,
   1.0);
begin
 if Arg<0 then begin Result:=2.0-Erfc(-Arg); Exit; end;
 if Arg<0.5 then begin Result:=1.0-Erf(Arg); Exit; end;
 if Arg>=10 then begin Result:=0; Exit; end;
 Result:=Exp(-Sqr(Arg))*Poly(Arg, P2)/Poly(Arg, Q2);
end;


procedure Asympt0(Arg:Double; var PZero, QZero:Double);
const
 P2:array[0..6] of double =
  (0.5393485083869438325262122897e7, 0.1233238476817638145232406055e8,
   0.8413041456550439208464315611e7, 0.2016135283049983642487182349e7,
   0.1539826532623911470917825993e6, 0.2485271928957404011288128951e4,
   0.0);
 Q2:array[0..6] of double =
  (0.5393485083869438325560444960e7, 0.1233831022786324960844856182e8,
   0.8426449050629797331554404810e7, 0.2025066801570134013891035236e7,
   0.1560017276940030940592769933e6, 0.2615700736920839685159081813e4,
   1.0);
 P3:array[0..6] of double =
  (-0.3984617357595222463506790588e4, -0.1038141698748464093880530341e5,
   -0.8239066313485606568803548860e4, -0.2365956170779108192723612816e4,
   -0.2262630641933704113967255053e3, -0.4887199395841261531199129300e1,
   -0.0);
 Q3:array[0..6] of double =
  (0.2550155108860942382983170882e6, 0.6667454239319826986004038103e6,
   0.5332913634216897168722255057e6, 0.1560213206679291652539287109e6,
   0.1570489191515395519392882766e5, 0.4087714673983499223402830260e3,
   1.0);

var  XSq:double;
begin
 XSq:=64.0/(Arg*Arg);
 Pzero:=Poly(XSq, P2)/Poly(XSq, Q2);
 Qzero:=8*Poly(XSq, P3)/Poly(XSq, Q3)/Arg;
end;


function J0(Arg:Double):Double;
const
 P1:array[0..8] of double =
  (0.4933787251794133561816813446e21, -0.1179157629107610536038440800e21,
   0.6382059341072356562289432465e19, -0.1367620353088171386865416609e18,
   0.1434354939140344111664316553e16, -0.8085222034853793871199468171e13,
   0.2507158285536881945555156435e11, -0.4050412371833132706360663322e8,
   0.2685786856980014981415848441e5);
 Q1:array[0..8] of double =
  (0.4933787251794133562113278438e21, 0.5428918384092285160200195092e19,
   0.3024635616709462698627330784e17, 0.1127756739679798507056031594e15,
   0.3123043114941213172572469442e12, 0.6699987672982239671814028660e9,
   0.1114636098462985378182402543e7,  0.1363063652328970604442810507e4,
   1.0);
var
 ArgSq, NN, PZero, QZero:Double;
begin
 if Arg<0 then  Arg:=-Arg;
 if Arg>8.0 then
  begin
    Asympt0(Arg, PZero, QZero);
    NN:=Arg-Pio4;
    Result:=Sqrt(Tpi/Arg)*(PZero*Cos(NN)-Qzero*Sin(NN));
    Exit;
  end;
 ArgSq:=Sqr(Arg);
 Result:=Poly(ArgSq,P1)/Poly(ArgSq,Q1);
end;

function Y0(Arg:Double):Double;
const
 P4:array[0..8] of double =
  (-0.2750286678629109583701933175e20, 0.6587473275719554925999402049e20,
   -0.5247065581112764941297350814e19, 0.1375624316399344078571335453e18,
   -0.1648605817185729473122082537e16, 0.1025520859686394284509167421e14,
   -0.3436371222979040378171030138e11, 0.5915213465686889654273830069e8,
   -0.4137035497933148554125235152e5);

  Q4:array[0..8] of double =
   (0.3726458838986165881989980e21,   0.4192417043410839973904769661e19,
    0.2392883043499781857439356652e17,0.9162038034075185262489147968e14,
    0.2613065755041081249568482092e12,0.5795122640700729537480087915e9,
    0.1001702641288906265666651753e7, 0.1282452772478993804176329391e4,
    1.0);
var NN, ArgSq, PZero, QZero:double;
begin
 if Arg<=0 then begin MathError(Domain, 'Y0'); Result:=-MaxDouble; Exit; end;
 if Arg>8.0 then
  begin
   Asympt0(Arg, PZero, QZero);
   NN:=Arg-Pio4;
   Result:=Sqrt(Tpi/Arg)*(PZero*Sin(NN)-Qzero*Cos(NN));
    Exit;
  end;
  ArgSq:=Sqr(Arg);
  Result:=Poly(ArgSq,P4)/Poly(ArgSq,Q4)+tPi*J0(Arg)*Ln(Arg);
end;


procedure Asympt1(Arg:Double; var PZero, QZero:Double);
const
 P2:array[0..5] of double =
  (-0.4435757816794127857114720794e7, -0.9942246505077641195658377899e7,
   -0.6603373248364939109255245434e7, -0.1523529351181137383255105722e7,
   -0.1098240554345934672737413139e6, -0.1611616644324610116477412898e4);
 Q2:array[0..6] of double =
  (-0.4435757816794127856828016962e7, -0.9934124389934585658967556309e7,
   -0.6585339479723087072826915069e7, -0.1511809506634160881644546358e7,
   -0.1072638599110382011903063867e6, -0.1455009440190496182453565068e4,
   1.0);
 P3:array[0..5] of double =
  (0.3322091340985722351859704442e5, 0.8514516067533570196555001171e5,
   0.6617883658127083517939992166e5, 0.1849426287322386679652009819e5,
   0.1706375429020768002061283546e4, 0.3526513384663603218592175580e2);
 Q3:array[0..6] of double =
  (0.7087128194102874357377502472e6, 0.1819458042243997298924553839e7,
   0.1419460669603720892855755253e7, 0.4002944358226697511708610813e6,
   0.3789022974577220264142952256e5, 0.8638367769604990967475517183e3,
   1.0);
var  XSq:double;
begin
 XSq:=64.0/(Arg*Arg);
 Pzero:=Poly(XSq, P2)/Poly(XSq, Q2);
 Qzero:=8*Poly(XSq, P3)/Poly(XSq, Q3)/Arg;
end;



function J1(Arg:Double):Double;
const
 P1:array[0..8] of double =
  (0.581199354001606143928050809e21, -0.6672106568924916298020941484e20,
   0.2316433580634002297931815435e19,-0.3588817569910106050743641413e17,
   0.2908795263834775409737601689e15,-0.1322983480332126453125473247e13,
   0.3413234182301700539091292655e10,-0.4695753530642995859767162166e7,
   0.2701122710892323414856790990e4);

 Q1:array[0..8] of double =
  (0.1162398708003212287858529400e22, 0.1185770712190320999837113348e20,
   0.6092061398917521746105196863e17, 0.2081661221307607351240184229e15,
   0.5243710262167649715406728642e12, 0.1013863514358673989967045588e10,
   0.1501793594998585505921097578e7,  0.1606931573481487801970916749e4,
   1.0);

var
 X, ArgSq, NN, PZero, QZero:Double;
begin
 X:=Arg;
 if X<0 then  X:=-X;
 if Arg>8.0 then
  begin
    Asympt1(Arg, PZero, QZero);
    NN:=X-3*Pio4;
    Result:=Sqrt(Tpi/X)*(PZero*Cos(NN)-Qzero*Sin(NN));
    if Arg<0 then Result:=-Result;
    Exit;
  end;
 ArgSq:=Sqr(Arg);
 Result:=Arg*Poly(ArgSq,P1)/Poly(ArgSq,Q1);
end;


function Y1(Arg:Double):Double;
const
 P4:array[0..8] of double =
  (-0.9963753424306922225996744354e23, 0.2655473831434854326894248968e23,
   -0.1212297555414509577913561535e22, 0.2193107339917797592111427556e20,
   -0.1965887462722140658820322248e18, 0.9569930239921683481121552788e15,
   -0.2580681702194450950541426399e13, 0.3639488548124002058278999428e10,
   -0.2108847540133123652824139923e7);

 Q4:array[0..9] of double =
  (0.5082067366941243245314424152e24, 0.5435310377188854170800653097e22,
   0.2954987935897148674290758119e20, 0.1082258259408819552553850180e18,
   0.2976632125647276729292742282e15, 0.6465340881265275571961681500e12,
   0.1128686837169442121732366891e10, 0.1563282754899580604737366452e7,
   0.1612361029677000859332072312e4,  1.0);

var NN, ArgSq, PZero, QZero:double;
begin
 if Arg<=0 then begin MathError(Domain, 'Y1'); Result:=-MaxDouble; Exit; end;
 if Arg>8.0 then
  begin
   Asympt1(Arg, PZero, QZero);
   NN:=Arg-3*Pio4;
   Result:=Sqrt(Tpi/Arg)*(PZero*Sin(NN)-Qzero*Cos(NN));
    Exit;
  end;
 ArgSq:=Sqr(Arg);
 Result:=Arg*Poly(ArgSq,P4)/Poly(ArgSq,Q4)+
         tPi*(J1(Arg)*Ln(Arg)-1/Arg);
end;

function Jn(N, Arg:Double):Double;
var NN, I:integer;
    A, B, Tmp, XSq, T:double;
begin
 NN:=Round(N);
 if NN<0 then begin NN:=-NN; Arg:=-Arg; end;
 if NN=0 then begin Result:=J0(Arg); Exit; end;
 if NN=1 then begin Result:=J1(Arg); Exit; end;
 if Arg=0 then begin Result:=0; Exit; end;
 if Arg<=NN then
  begin
   A:=J0(Arg); B:=J1(Arg);
   for I:=1 to NN-1 do
    begin Tmp:=B; B:=2*I/Arg*B-A; A:=Tmp; end;
   Result:=B;
   Exit;
  end;
 XSq:=Sqr(Arg); T:=0;
 for I:=NN+16 downto NN do T:=XSq/(2*I-T);
 T:=Arg/(2.0*NN-T);
 A:=NN; B:=1;
 for I:=NN-1 downto 1 do
  begin Tmp:=B; B:=(2.0*I/Arg)*B-A; A:=Tmp; end;
 Result:=T*J0(Arg)/B;
end;

function Yn(N, Arg:Double):Double;
var NN, I:integer;
    A, B, Tmp, Sign:double;
begin
  if Arg<=0 then begin MathError(Domain, 'Yn'); Result:=-MaxDouble; Exit; end;
  Sign:=1;
  NN:=Round(N);
  if NN<0 then begin NN:=-NN; if Odd(NN) then Sign:=-1; end;
  if NN=0 then begin Result:=Y0(Arg); Exit; end;
  if NN=1 then begin Result:=Sign*Y1(Arg); Exit; end;
  A:=Y0(Arg); B:=Y1(Arg);
  for I:=1 to NN-1 do
   begin Tmp:=B; B:=2*I/Arg*B-A; A:=Tmp; end;
  Result:=Sign*b;
end;

var SgnGam:double; {  - }

function StirF(X:Double):Double;{ }
const
 Stir:Array [0..4] Of Double=
  (7.87311395793093628397E-4, -2.29549961613378126380E-4,
  -2.68132617805781232825E-3,  3.47222221605458667310E-3,
   8.33333333333482257126E-2);
 SQTPI=2.50662827463100050242E0;
var y, w, v:Double;
begin
 w:=1.0/x; w:=1.0+(w*PolEvl(w, STIR)); y:=Exp(x);
 if (x>143.01608) then { Avoid overflow in pow() }
  begin v:=Power(x, (0.5*x)-0.25); y:=v*(v/y); end
  else y:=Power(x, x-0.5)/y;
 Result:=SQTPI*y*w;
end; { stirf }

function Gamma(x:Double):Double;
label Small;
const
   PP:Array [0..6] Of Double=
    (1.60119522476751861407E-4,  1.19135147006586384913E-3,
     1.04213797561761569935E-2,  4.76367800457137231464E-2,
     2.07448227648435975150E-1,  4.94214826801497100753E-1,
     9.99999999999999996796E-1);
   QQ:Array [0..7] Of Double=
    (-2.31581873324120129819E-5,  5.39605580493303397842E-4,
     -4.45641913851797240494E-3,  1.18139785222060435552E-2,
      3.58236398605498653373E-2, -2.34591795718243348568E-1,
      7.14304917030273074085E-2, 1.00000000000000000320E0);

var p, q, z:Double;
    i:Integer;
begin

 SgnGam:=1;
 q:=Abs(x);

 if q>33.0 then
 begin
  if x<0.0 then
   begin
    p:=floor(q);
    if p=q then
     begin
      MathError(OVERFLOW, 'gamma');
      Result:=SgnGam*INFINITY;
     end;
    i:=Round(p);
    if (i and 1)=0  then SgnGam:=-1;
    z:=q-p;
    if z>0.5 then begin p:=p+1.0; z:=q-p; end;
    z:=q*Sin(PI*z);
    if z=0.0 then
     begin
      MathError(OVERFLOW, 'gamma');
      Result:=SgnGam*INFINITY;
     end;
    z:=Abs(z);
    z:=PI/(z*StirF(q) );
   end
  else z:=StirF(x);
  Result:=sgngam*z; Exit;
 end;
 {if q<=33.0}
 z:=1.0;
 while x>=3.0  do begin x:=x-1; z:=z*x; end;
 while x<0.0 do
  begin if x>-1.E-9 then goto small; z:=z/x; x:=x+1.0; end;
 while x<2.0 do
  begin if x<1.e-9 then goto small; z:=z/x; x:=x+1.0; end;
 if x=2.0 then begin Result:=z; Exit; end;
 x:=x-2.0;
 Result:=z*PolEvl(x, PP)/PolEvl(x, QQ);
 Exit;

Small:
 if x=0.0 then
  begin MathError(SING, 'gamma'); Result:=INFINITY; end
 else Result:=z/((1.0+0.5772156649015329*x)*x);

end;


{Logarithm of gamma function}
function LnGam(x:Double):Double;
const
  LOGPI=1.14472988584940017414;
  LS2PI = 0.91893853320467274178;
  MAXLGM=2.556348e305;
  A:Array [0..4] Of Double=
    (8.11614167470508450300E-4, -5.95061904284301438324E-4,
     7.93650340457716943945E-4, -2.77777777730099687205E-3,
     8.33333333333331927722E-2);
  B:Array [0..5] Of Double=
    (-1.37825152569120859100E3, -3.88016315134637840924E4,
     -3.31612992738871184744E5, -1.16237097492762307383E6,
     -1.72173700820839662146E6, -8.53555664245765465627E5);
  C:Array [0..5] Of Double=
    (-3.51815701436523470549E2, -1.70642106651881159223E4,
     -2.20528590553854454839E5, -1.13933444367982507207E6,
     -2.53252307177582951285E6, -2.01889141433532773231E6);
var p, q, u, w, z:Double;
    i:Integer;
begin
 SgnGam:=1;
 if x<-34.0 then
  begin
   q:=-x;
   w:=LnGam(q); {note this modifies sgngam!}
   p:=floor(q);
   if p=q then
    begin MathError(Sing, 'LnGam'); Result:=INFINITY; Exit; end;
   i:=Round(p);
   if (i And 1)=0 then sgngam:=-1 else sgngam:=1;
   z:=q-p;
   if (z>0.5) then begin p:=p+1.0; z:=p-q; end;
   z:=q*Sin(Pi*z);
   if z=0.0 then begin MathError(Sing, 'LnGam'); Result:=INFINITY; Exit; end;
   Result:=LOGPI-Ln(z)-w;
  end;
 if x<13.0 then
  begin
   z:=1.0; p:=0.0; u:=x;
   while u>=3.0 do begin p:=p-1.0; u:=x+p; z:=z*u; end;
   While (u<2.0) Do
    begin
     if u=0.0 then begin MathError(Sing, 'LnGam'); Result:=INFINITY; Exit; end;
     z:=z/u; p:=p+1.0; u:=x+p;
    end;
   if z<0.0 then begin sgngam:=-1; z:=-z; end
    else sgngam:=1;
   if (u=2.0) then begin Result:=(Ln(z)); Exit; end;
   p:=p-2.0; x:=x+p;
   p:=x*PolEvl(x, B)/p1evl(x, C);
   Result:=(Ln(z)+p);
   Exit;
  end { if };
 if (x>2.556348e305) then begin Result:=SgnGam*INFINITY; Exit; end;
 q:=((x-0.5)*Ln(x))-x+LS2PI;
 if x>1.0e8 then begin Result:=q; Exit; end;
 p:=1.0/(x*x);
 if (x>=1000.0) then
    q:=q+((((7.9365079365079365079365e-4*p)-
            2.7777777777777777777778e-3)*p)+
            0.0833333333333333333333)/x
 else q:=q+PolEvl(p, A)/x;
 Result:=(q);
end;


function GammaAsym(Arg:Double):Double;
const
 Goobie=0.9189385332046727417803297;
 P1:array[0..5] of double =
  (0.83333333333333101837e-1, -0.277777777735865004e-2,
   0.793650576493454e-3,      -0.5951896861197e-3,
   0.83645878922e-3,          -0.1633436431e-2);
var ArgSq:double;
begin
 ArgSq:=1.0/(Arg*Arg);
 Result:=(Arg-0.5)*Ln(Arg)-Arg+Goobie+Poly(ArgSq, P1)/arg;
end;


function GammaPos(Arg:Double):Double;
const
 P2:array[0..6] of double =
  (-0.42353689509744089647e5, -0.20886861789269887364e5,
   -0.87627102978521489560e4, -0.20085274013072791214e4,
   -0.43933044406002567613e3, -0.50108693752970953015e2,
   -0.67449507245925289918e1);
 Q2:array[0..7] of double =
  (-0.42353689509744090010e5, -0.29803853309256649932e4,
    0.99403074150827709015e4, -0.15286072737795220248e4,
   -0.49902852662143904834e3,  0.18949823415702801641e3,
   -0.23081551524580124562e2,  1.0);

var S:double;
begin
 if Arg<2 then begin GammaPos:=GammaPos(Arg+1.0)/arg; Exit; end;
 if Arg>3 then begin GammaPos:=GammaPos(Arg-1.0)*(arg-1); Exit; end;
 S:=Arg-2;
 Result:=Poly(S, P2)/Poly(S, Q2);
end;

function GammaNeg(Arg:Double):Double;
var Tmp:double;
begin
 Arg:=-arg; Tmp:=Sin(Pi*arg);
 if Tmp=0 then begin MathError(Domain, 'Gamma'); Result:=MaxDouble; Exit; end;
 if Tmp<0 then Tmp:=-Tmp else SgnGam:=-1;
 Result:=-Ln(Arg*GammaPos(Arg)*Tmp/Pi);
end;

function LogGamma(Arg:Double):Double;
begin
 SgnGam:=1.0;
 if Arg<=0.0 then begin Result:=GammaNeg(arg); Exit; end;
 if Arg>8 then begin Result:=GammaAsym(Arg); Exit; end;
 Result:=Ln(GammaPos(Arg));
end;

{Incomplete beta integral }
const
 big = 4.503599627370496e15;
 biginv =  2.22044604925031308085e-16;

function incbcf(a, b, x:double):double;
Label cdone;
var xk, pk, pkm1, pkm2, qk, qkm1, qkm2, k1, k2,
    k3, k4, k5,   k6,   k7, k8,   r,    t,  ans,
    thresh:Double;
    n:Integer;
begin
 k1:=a; k2:=a+b; k3:=a; k4:=a+1.0; k5:=1.0; k6:=b-1.0;
 k7:=k4; k8:=a+2.0; pkm2:=0.0; qkm2:=1.0; pkm1:=1.0;
 qkm1:=1.0; ans:=1.0; r:=1.0; n:=0;
 thresh:=3.0*MathEps;
 Repeat
  xk:=-(x*k1*k2)/(k3*k4); pk:=pkm1+(pkm2*xk); qk:=qkm1+(qkm2*xk);
  pkm2:=pkm1; pkm1:=pk; qkm2:=qkm1; qkm1:=qk; xk:=(x*k5*k6)/(k7*k8);
  pk:=pkm1+(pkm2*xk); qk:=qkm1+(qkm2*xk); pkm2:=pkm1;
  pkm1:=pk; qkm2:=qkm1; qkm1:=qk;
  if qk<>0 then r:=pk/qk;
  if (r<>0) then begin t:=Abs((ans-r)/r); ans:=r; end
   else t:=1.0;
  if t<thresh then Break;
  k1:=k1+1.0; k2:=k2+1.0; k3:=k3+2.0; k4:=k4+2.0;
  k5:=k5+1.0; k6:=k6-1.0; k7:=k7+2.0; k8:=k8+2.0;
  if (Abs(qk)+Abs(pk))>big then
   begin
    pkm2:=pkm2*biginv; pkm1:=pkm1*biginv;
    qkm2:=qkm2*biginv; qkm1:=qkm1*biginv;
   end;
  if ((Abs(qk)<biginv)) Or ((Abs(pk)<biginv)) then
   begin
    pkm2:=pkm2*big; pkm1:=pkm1*big; qkm2:=qkm2*big; qkm1:=qkm1*big;
   end;
  Inc(n)
 Until n>=300;
 Result:=ans;
end;

Function incbd(a, b, x:double):double;
var xk, pk, pkm1, pkm2, qk, qkm1, qkm2, k1, k2,
    k3, k4, k5, k6, k7, k8, r, t, ans, z, thresh:Double;
    n:Integer;
begin
 k1:=a; k2:=b-1.0; k3:=a; k4:=a+1.0; k5:=1.0; k6:=a+b;
 k7:=a+1.0; k8:=a+2.0; pkm2:=0.0; qkm2:=1.0; pkm1:=1.0;
 qkm1:=1.0; z:=x/(1.0-x); ans:=1.0; r:=1.0; n:=0;
 thresh:=3.0*MathEps;
 Repeat
  xk:=-(z*k1*k2)/(k3*k4); pk:=pkm1+(pkm2*xk);
  qk:=qkm1+(qkm2*xk); pkm2:=pkm1; pkm1:=pk;
  qkm2:=qkm1; qkm1:=qk; xk:=(z*k5*k6)/(k7*k8);
  pk:=pkm1+(pkm2*xk); qk:=qkm1+(qkm2*xk); pkm2:=pkm1;
  pkm1:=pk; qkm2:=qkm1; qkm1:=qk;
  if (qk<>0) then r:=pk/qk;
  if (r<>0) then begin t:=Abs((ans-r)/r); ans:=r; end
   else t:=1.0;
  if t<thresh then Break;
  k1:=k1+1.0; k2:=k2-1.0; k3:=k3+2.0; k4:=k4+2.0;
  k5:=k5+1.0; k6:=k6+1.0; k7:=k7+2.0; k8:=k8+2.0;
  if (Abs(qk)+Abs(pk))>big then
   begin
    pkm2:=pkm2*biginv; pkm1:=pkm1*biginv;
    qkm2:=qkm2*biginv; qkm1:=qkm1*biginv;
   end;
  if ((Abs(qk)<biginv)) or ((Abs(pk)<biginv)) then
   begin
    pkm2:=pkm2*big; pkm1:=pkm1*big; qkm2:=qkm2*big; qkm1:=qkm1*big;
   end;
  Inc(n)
 until n>=300;
 Result:=ans;
end;

{ Power series for incomplete beta integral. }
{ Use when b*x is small and x not too close to 1.  }

Function pseries(a, b, x:double):double;
var s, t, u, v, n, t1, z, ai:Double;
begin
 ai:=1.0/a; u:=(1.0-b)*x; v:=u/(a+1.0); t1:=v;
 t:=u; n:=2.0; s:=0.0; z:=MathEps*ai;
 while Abs(v)>z do
  begin
   u:=(n-b)*x/n; t:=t*u; v:=t/(a+n); s:=s+v; n:=n+1.0;
  end;
 s:=s+t1; s:=s+ai; u:=a*Ln(x);
 if ((a+b)<171.624376956302725) and (Abs(u)<MAXLOG) then
  begin
   t:=gamma(a+b)/(gamma(a)*gamma(b)); s:=s*t*Power(x, a);
  end
 else
  begin
   t:=LnGam(a+b)-LnGam(a)-LnGam(b)+u+Ln(s);
   if (t<MinLog) then s:=0.0
   else s:=Exp(t)
  end;
 Result:=s;
end;
{Incomplete beta integral }
function IncBet(aa, bb, xx:Double):Double;
Label done;
var a, b, t, x, xc, w, y:Double;
    flag:Integer;
begin
if (aa<=0.0) or (bb<=0.0) then
 begin MathError(DOMAIN,'incbet');Result:=0; Exit; end;
 if (xx<=0)or(xx>=1.0) then
  begin
   if xx=0 then begin Result:=0; Exit; end;
   if xx=1.0 then begin Result:=1.0; Exit; end;
   MathError(DOMAIN, 'incbet'); Result:=0; Exit;
  end;
 flag:=0;
 if ((bb*xx)<=1.0) and (xx<=0.95) then
  begin
   t:=pseries(aa, bb, xx); Goto done;
  end ;
 w:=1.0-xx;
 {Reverse a and b if x is greater than the mean. }
 if xx>(aa/(aa+bb)) then
  begin flag:=1; a:=bb; b:=aa; xc:=xx; x:=w; end
 else begin a:=aa; b:=bb; xc:=w; x:=xx; end;
 if ((flag=1) and ((b*x)<=1.0)) and (x<=0.95) then
  begin t:=pseries(a, b, x); Goto done; end;
 y:=(x*(a+b-2.0))-(a-1.0);
 if (y<0.0) then w:=incbcf(a, b, x)
  else w:=incbd(a, b, x)/xc;
 y:=a*Ln(x); t:=b*Ln(xc);
 if (((a+b)<171.624376956302725) And (Abs(y)<MAXLOG) And
    (Abs(t)<MAXLOG)) then
  begin
   t:=Power(xc, b); t:=t*Power(x, a); t:=t/a; t:=t*w;
   t:=t*gamma(a+b)/(gamma(a)*gamma(b));
   Goto done;
  end;
 y:=y+t+LnGam(a+b)-LnGam(a)-LnGam(b); y:=y+Ln(w/a);
 if (y<MinLog) then t:=0.0
  else t:=Exp(y);
done:
 if flag=1 then
   begin if t<=MathEps then t:=1.0-MathEps else t:=1.0-t; end { if };
 Result:=t;
end;

{Inverse of imcomplete beta integral}
function IncBI(aa, bb, yy0:Double):Double;
label Newt, ihalve;
var a, b, y0, d, y, x, x0, x1, lgm, yp,
    di, dithresh, yl, yh, xt:double;
    i, rflg, dir, nflg:integer;

    function Done:double;
     begin
     if rflg<>0 then
      begin if x<=MathEps then x:=1.0-MathEps else x:=1.0-x; end;
     Result:=x;
    end;
begin
if yy0<=0 then begin Result:=0; Exit; end;
if yy0>=1.0 then begin Result:=1; Exit; end;
x0:=0.0; yl:=0.0; x1:=1.0; yh:=1.0; nflg:=0;

 if(aa<=1.0)or(bb<=1.0)then
 begin
  dithresh:=1.0e-6; rflg:=0; a:=aa; b:=bb; y0:=yy0;
  x:=a/(a+b); y:=incbet(a, b, x); goto ihalve;
 end
 else dithresh:=1.0e-4;
{approximation to inverse function }
 yp:=-ndtri(yy0);
 if yy0>0.5 then
  begin rflg:=1; a:=bb; b:=aa; y0:=1.0-yy0; yp:=-yp; end
   else begin rflg:=0; a:=aa; b:=bb; y0:=yy0; end;
 lgm:=(yp*yp-3.0)/6.0;
 x:=2.0/(1.0/(2.0*a-1.0) + 1.0/(2.0*b-1.0));
 d:=yp*sqrt(x+lgm)/x
        -(1.0/(2.0*b-1.0)-1.0/(2.0*a-1.0))
        * lgm+5.0/6.0-2.0/(3.0*x);
 d:=2.0*d;
 if d<MinLog then
  begin
   x:=1.0; MathError(UNDERFLOW, 'incbi');
   Result:=Done; exit;
  end;
 x:=a/(a+b*exp(d)); y:=incbet(a, b, x); yp:=(y-y0)/y0;
 if Abs(yp)<0.2 then goto newt;
{ Resort to interval halving if not close enough. }
ihalve:
 dir:=0; di:=0.5;
 for i:=0 to 99 do
  begin
   if i<>0 then
   begin
    x:=x0 + di*(x1-x0);
    if x=1.0 then x:=1.0-MathEps;
    if x=0.0 then
    begin
      di:=0.5; x:=x0+di*(x1-x0);
      if x=0.0 then
       begin MathError(UNDERFLOW, 'incbi'); Result:=Done; exit; end;
    end;
    y:=incbet(a, b, x);
    yp:=(x1-x0)/(x1+x0);
    if Abs(yp)<dithresh then goto newt;
    yp:=(y-y0)/y0;
    if Abs(yp)<dithresh then goto newt;
   end;
   if y<y0 then
    begin
     x0:=x;
     yl:=y;
     if dir<0 then begin dir:=0; di:=0.5; end
      else if dir>3 then di:=1.0-(1.0-di)*(1.0-di)
       else if dir>1 then di:=0.5*di+0.5
        else di:=(y0-y)/(yh-yl);
     dir:=dir+1;
     if x0>0.75 then
      begin
       if rflg=1 then
        begin rflg:=0; a:=aa; b:=bb; y0:=yy0; end
         else begin rflg:=1; a:=bb; b:=aa; y0:=1.0-yy0; end;
       x:=1.0-x; y:=incbet(a, b, x); x0:=0.0; yl:=0.0;
       x1:=1.0; yh:=1.0; goto ihalve;
      end
    end
   else
    begin
     x1:=x;
     if (rflg=1)and(x1<MathEps) then begin x:=0.0; Result:=Done; Exit; end;
     yh:=y;
     if dir>0 then begin dir:=0; di:=0.5; end
      else if dir<-3 then di:=di*di
       else if dir<-1 then di:=0.5*di
        else di:=(y-y0)/(yh-yl);
     dir:=dir-1;
    end;
  end;
 MathError(Ploss, 'incbi');
 if x0>=1.0 then begin x:=1.0-MathEps; Result:=Done; Exit; end;
 if x<=0.0 then
  begin
   MathError(UNDERFLOW, 'incbi');
   x:=0.0; Result:=Done; exit;
  end;

newt:
 if nflg<>0 then begin Result:=Done; Exit; end;
 nflg:=1;
 lgm:=lngam(a+b)-lngam(a)-lngam(b);
 for i:=0 to 7 do
  begin
  { Compute the function at this point. }
  if i<>0 then y:=incbet(a,b,x);
  if y<yl then begin x:=x0; y:=yl; end
  else if y>yh then begin x:=x1; y:=yh; end
  else if y<y0 then begin x0:=x; yl:=y; end
  else begin x1:=x; yh:=y; end;
  if(x=1.0)or(x=0.0)then break;
  { Compute the derivative of the function at this point. }
  d:=(a-1.0)*ln(x)+(b-1.0)*ln(1.0-x)+lgm;
  if d<MinLog then begin Result:=Done; Exit end;;
  if d>MAXLOG then break;
  d:=exp(d);
  { Compute the step to the next approximation of x. }
  d:=(y-y0)/d; xt:=x-d;
  if xt<=x0 then
   begin
    y:=(x-x0)/(x1-x0); xt:=x0+0.5*y*(x-x0);
    if xt<=0.0 then break;
   end;
  if xt>=x1 then
   begin
    y:=(x1-x)/(x1-x0); xt:=x1-0.5*y*(x1-x);
    if xt>=1.0 then break;
   end;
  x:=xt;
  if(Abs(d/x)<128.0*MathEps) then begin Result:=Done; Exit; end;
 end;
{ Did not converge.  }
 dithresh:=256.0*MathEps;
 goto ihalve;
end;

function ndtri(y0:double):double;
const
 s2pi = 2.50662827463100050242E0;{Sqrt(2Pi)}
 {approximation for 0 <= |y - 0.5| <= 3/8}
 P0:Array [0..4] Of Double=
  (-5.99633501014107895267E1, 9.80010754185999661536E1,
   -5.66762857469070293439E1, 1.39312609387279679503E1,
   -1.23916583867381258016E0);
 Q0:Array [0..7] Of Double=
  (1.95448858338141759834E0, 4.67627912898881538453E0,
   8.63602421390890590575E1, -2.25462687854119370527E2,
   2.00260212380060660359E2, -8.20372256168333339912E1,
   1.59056225126211695515E1, -1.18331621121330003142E0);

{Approximation for interval z = sqrt(-2 log y ) between 2 and 8
 i.e., y between exp(-2) = .135 and exp(-32) = 1.27e-14.}
 P1:Array [0..8] Of Double=
  (4.05544892305962419923E0,   3.15251094599893866154E1,
   5.71628192246421288162E1,   4.40805073893200834700E1,
   1.46849561928858024014E1,   2.18663306850790267539E0,
  -1.40256079171354495875E-1, -3.50424626827848203418E-2,
  -8.57456785154685413611E-4);
 Q1:Array [0..7] Of Double=
  (1.57799883256466749731E1,   4.53907635128879210584E1,
   4.13172038254672030440E1,   1.50425385692907503408E1,
   2.50464946208309415979E0,  -1.42182922854787788574E-1,
  -3.80806407691578277194E-2, -9.33259480895457427372E-4);
{Approximation for interval z = sqrt(-2 log y ) between 8 and 64
 * i.e., y between exp(-32) = 1.27e-14 and exp(-2048) = 3.67e-890.}
 P2:Array [0..8] Of Double=
  (3.23774891776946035970E0,   6.91522889068984211695E0,
   3.93881025292474443415E0,   1.33303460815807542389E0,
   2.01485389549179081538E-1,  1.23716634817820021358E-2,
   3.01581553508235416007E-4,  2.65806974686737550832E-6,
   6.23974539184983293730E-9);
 Q2:Array [0..7] Of Double=
  (6.02427039364742014255E0,   3.67983563856160859403E0,
   1.37702099489081330271E0,   2.16236993594496635890E-1,
   1.34204006088543189037E-2,  3.28014464682127739104E-4,
   2.89247864745380683936E-6,  6.79019408009981274425E-9);
  Expm2=0.13533528323661269189;{Exp(-2)}
var
    x, y, z, y2, x0, x1:Double;
    code:Integer;
begin
 if (y0<=0.0) then begin MathError(DOMAIN, 'ndtri'); ndtri:=-MaxDouble; Exit end;
 if (y0>=1.0) then begin MathError(DOMAIN, 'ndtri'); ndtri:=MaxDouble; Exit end;
 code:=1; y:=y0;
 if y>(1.0-Expm2) then begin y:=1.0-y; code:=0; end;
 if (y>Expm2) then
  begin
   y:=y-0.5; y2:=y*y;
   x:=y+(y*(y2*PolEvl(y2, P0)/p1evl(y2, Q0)));
   x:=x*s2pi; Result:=X; Exit;
  end;
 x:=Sqrt(-2.0*Ln(y)); x0:=x-(Ln(x)/x); z:=1.0/x;
 if (x<8.0) then x1:=z*PolEvl(z, P1)/p1evl(z, Q1)
  else x1:=z*PolEvl(z, P2)/p1evl(z, Q2);
 x:=x0-x1;
 if code<>0 then x:=-x;
 Result:=x
end;

Function NDtr(x:Double):Double;  { }
begin
 NDtr:=0.5*(Erf(x/Sqrt2)+1);
end;


function pdtrc(k, m:Double):Double;
var v:Double;
begin
 k:=Round(k);
 if ((k<0)) or ((m<=0.0)) then
  begin MathError(DOMAIN, 'pdtrc'); Result:=0; Exit; end;
 v:=k+1; pdtrc:=igam(v, m);
end; { pdtrc }

function pdtr(k, m:Double):Double;
var v:Double;
begin
 k:=Round(k);
 if ((k<0)) or ((m<=0.0)) then
  begin MathError(DOMAIN, 'pdtr'); Result:=0; Exit; end;
 v:=k+1; pdtr:=igamc(v, m);
end;

function pdtri(k, y:Double):Double;
var v:Double;
begin
 k:=Round(k);
 if (k<0)or(y<0.0)or(y>=1.0) then
 begin MathError(DOMAIN, 'pdtri'); Result:=0; Exit; end;
 v:=k+1;
 pdtri:=igami(v, y);
end;

function stdtr(k, t:Double):Double;
var
    x, rk, z, f, tz, p, xsqk:Double;
    j:Integer;
begin
 k:=Round(k);
 if k<=0 then begin MathError(DOMAIN, 'stdtr'); Result:=0; Exit; end;
 if t=0 then begin Result:=0.5; Exit; end;
 if t<-2.0 then
  begin
   rk:=k; z:=rk/(rk+(t*t)); Result:=0.5*IncBet(0.5*rk, 0.5, z); Exit;
  end;
 if t<0 then x:=-t else x:=t;
 rk:=k;
 {degrees of freedom }
 z:=1.0+((x*x)/rk);
 {test if k is odd or even }
 if Odd(Round(k)) then
  begin
   xsqk:=x/Sqrt(rk);
   p:=ArcTan(xsqk);
   if k>1 then
    begin
     f:=1.0; tz:=1.0; j:=3;
     while (j<=(k-2))And((tz/f)>MathEps) do
      begin tz:=tz*(j-1)/(z*j); f:=f+tz; j:=j+2; end;
     p:=p+f*xsqk/z;
    end;
   p:=p*2.0/Pi;
  end
 else
  begin
   f:=1.0; tz:=1.0; j:=2;
   while (j<=(k-2)) and ((tz/f)>MathEps) do
    begin tz:=tz*(j-1)/(z*j); f:=f+tz; j:=j+2; end;
   p:=f*x/Sqrt(z*rk);
  end;
 if t<0 then p:=-p;
 Result:=0.5+(0.5*p);
end;


function stdtri(k, p:Double):Double;
var t, rk, z, s1, s2, s3:Double;
    rflg:Integer;
begin
 k:=Round(k);
 if (k<=0)or(p<=0.0)or(p>=1.0) then
 begin MathError(DOMAIN, 'stdtri'); Result:=0; Exit; end;
 rk:=k;
 if (p>0.25)and(p<0.75) then
   begin
    if (p=0.5) then begin Result:=0; Exit; end;
    z:=1.0-(2.0*p); s1:=0.5; s2:=0.5*rk; s3:=Abs(z);
    z:=incbi(s1, s2, s3);
    t:=Sqrt(rk*z/(1.0-z));
    if (p<0.5) then t:=-t;
    Result:=t; Exit;
   end { if };
 rflg:=-1;
 if p>=0.5 then begin p:=1.0-p; rflg:=1; end;
 s1:=0.5*rk; s2:=0.5;  s3:=2.0*p;
 z:=IncBi(s1, s2, s3);
 if MaxDouble*z<rk then begin Result:=rflg*MaxDouble; Exit;end;
 Result:=rflg*Sqrt((rk/z)-rk);
end;

{Relative error approximations for function arguments near unity.}
{    log1p(x) = log(1+x) }
{    expm1(x) = exp(x) - 1 }
{    cosm1(x) = cos(x) - 1 }
function log1p(x:Double):Double;
const x1=0.70710678118654752440;{1/sqrt(2)}
      x2=1.41421356237309504880;{sqrt(2)}
  LP:Array [0..6] Of Double=
   (4.5270000862445199635215E-5,  4.9854102823193375972212E-1,
    6.5787325942061044846969E0,   2.9911919328553073277375E1,
    6.0949667980987787057556E1,   5.7112963590585538103336E1,
    2.0039553499201281259648E1);
  LQ:Array [0..5] Of Double=
   (1.5062909083469192043167E1,   8.3047565967967209469434E1,
    2.2176239823732856465394E2,   3.0909872225312059774938E2,
    2.1642788614495947685003E2,   6.0118660497603843919306E1);
var z:Double;
begin
 z:=1.0+x;
 if (z<x1)or(z>Sqrt2) then begin Result:=Ln(z); Exit;end;
 z:=x*x;
 z:=(-0.5*z)+(x*(z*PolEvl(x,LP)/p1evl(x, LQ)));
 Result:=(x+z);
end;

function Expm1(x:Double):Double;
const
  EP:Array [0..2] Of Double=
   (1.2617719307481059087798E-4, 3.0299440770744196129956E-2,
    9.9999999999999999991025E-1);
  EQ:Array [0..3] Of Double=
   (3.0019850513866445504159E-6, 2.5244834034968410419224E-3,
    2.2726554820815502876593E-1, 2.0000000000000000000897E0);
var r:Double;
    xx:Double;
begin
 r:=0;
 if (((x<-0.5)) Or ((x>0.5))) then begin Result:=(Exp(x)-1.0); Exit; end;
 xx:=x*x;
 r:=x*PolEvl(xx, EP)/(PolEvl(xx, EQ)-r);
 Result:=(r+r);
end;

{ cosm1(x) = cos(x) - 1  }

function cosm1(x:Double):Double;
const
 coscof:Array [0..6] Of Double=
  (4.7377507964246204691685E-14,  -1.1470284843425359765671E-11,
   2.0876754287081521758361E-9,   -2.7557319214999787979814E-7,
   2.4801587301570552304991E-5,   -1.3888888888888872993737E-3,
   4.1666666666666666609054E-2);
var xx:Double;
begin
 if (x<-PIO4)or(x>PIO4) then begin Result:=(Cos(x)-1.0); Exit; end;
 xx:=x*x;
 Result:=(-0.5*xx)+(xx*xx*PolEvl(xx, coscof));
end;

Function bdtrc(k, n, p:Double):Double;
{Complemented binomial distribution }
var dk, dn:Double;
begin
 if (p<0.0)or(p>1.0)or(n<k) then begin MathError(DOMAIN, 'bdtrc'); BdTrc:=0.0; Exit; end;
 if (k<0) then begin BdTrc:=1.0; Exit; end;
 if (k=n) then begin BdTrc:=0.0; Exit; end;
 dn:=n-k;
 if (k=0) then
   begin
    if (p<0.01) then dk:=-expm1(dn*log1p(-p))
     else dk:=1.0-Power(1.0-p, dn);
   end { if }
 else begin dk:=k+1; dk:=incbet(dk, dn, p); end;
 Result:=dk;
end;


function bdtr(k, n, p:Double):Double;
{Inverse binomial distribution }
var dk, dn:Double;
begin
 if (p<0.0)or(p>1.0) then begin MathError(DOMAIN, 'bdtr'); Result:=0.0; Exit; end;
 if (k<0)or(n<k) then begin MathError(DOMAIN, 'bdtr'); Result:=0.0; Exit; end;
 if k=n then begin bdtr:=1.0; Exit; end;
 dn:=n-k;
 if k=0 then dk:=Power(1.0-p, dn)
  else begin dk:=k+1; dk:=incbet(dn, dk, 1.0-p);end;
 Result:=dk;
end;


Function bdtri(k, n, y:Double):Double;
var dk, dn, p:Double;
begin
 if(y<0.0)or(y>1.0)then begin MathError( DOMAIN,'bdtri'); Result:=0; Exit; end;
 if(k<0)or(n<=k)then begin MathError( DOMAIN,'bdtri'); Result:=0; Exit; end;
 dn:=n-k;
 if (k=0) then
  begin
   if (y>0.8) then p:=-expm1(log1p(y-1.0)/dn)
    else p:=1.0-Power(y, 1.0/dn);
  end { if }
 else
  begin
   dk:=k+1; p:=incbet(dn, dk, 0.5);
   if p>0.5 then p:=incbi(dk, dn, 1.0-y)
    else p:=1.0-incbi(dn, dk, y);
  end;
 Result:=(p);
end;

function btdtr(a:Double; b:Double; x:Double):Double;
begin
 btdtr:=incbet(a, b, x);
end; { btdtr }

function chdtrc(df:Double; x:Double):Double;
begin
 if (x<0.0)or(df<1.0) then begin MathError(DOMAIN, 'chdtrc'); Result:=0; Exit; end;
 Result:=IGamC(df/2.0, x/2.0);
end;

function chdtr(df:Double; x:Double):Double;
begin
 if (x<0.0)or(df<1.0) then begin MathError(DOMAIN, 'chdtr'); Result:=0; Exit; end;
 Result:=Igam(df/2.0, x/2.0);
end;


function chdtri(df:Double; y:Double):Double;
begin
 if (y<0.0)or(y>1.0)or(df<1.0) then begin MathError(DOMAIN, 'chdtri'); Result:=0; Exit; end;
 Result:=2*igami(0.5*df, y);
end;

Function fdtrc(a, b, x:Double):Double;
begin
 if (a<1)or(b<1)or(x<0.0) then begin MathError(DOMAIN, 'fdtrc'); Result:=0; Exit; end;
 Result:=(incbet(0.5*b, 0.5*a, b/(b+(a*x))));
end; { fdtrc }

function FDtr(a, b, x:Double):Double;
begin
if (a<1)or(b<1)or(x<0.0) then begin MathError(DOMAIN, 'fdtr'); Result:=0; Exit; end;
 fdtr:=(incbet(0.5*a, 0.5*b, (a*x)/(b+a*x)));
end;

function FDtrI(a, b, y:Double):Double;
var w, x:Double;
begin
if (a<1)or(b<1)or(y<=0.0)or(y>1.0) then begin MathError(DOMAIN, 'fdtri'); Result:=0; Exit; end;
{ Compute probability for x = 0.5.  }
 w:=incbet(0.5*b, 0.5*a, 0.5);
{ if that is greater than y, then the solution w < .5. }
{ Otherwise, solve at 1-y to remove cancellation in (b - b*w).  }
 if(w>y)or(y<0.001) then
  begin w:=incbi(0.5*b, 0.5*a, y); x:=(b-(b*w))/(a*w); end
  else begin w:=incbi(0.5*a, 0.5*b, 1.0-y); x:=b*w/(a*(1.0-w)); end;
 FDtrI:=x;
end;

function GDtr(a:Double; b:Double; x:Double):Double;
begin
 if x<0.0 then begin MathError(DOMAIN, 'gdtr'); Result:=0; Exit; end;
 GDtr:=(igam(b, a*x));
end;


Function GDtrC(a:Double; b:Double; x:Double):Double;
begin
 if x<0.0 then begin MathError( DOMAIN,'GDtrc'); Result:=0; exit; end;
 GDtrC:=(igamc(b, a*x));
end;


function IGamC(a, x:Double):Double;
var ans, ax, c, yc, r, t, y, z, pk, pkm1, pkm2, qk, qkm1, qkm2:Double;
begin
 if(x<=0)or(a<=0) then begin igamc:=1.0; Exit; end;
 if (x<1.0)or(x<a) then begin igamc:=(1.0-igam(a, x)); Exit; end;
 ax:=(a*Ln(x))-x-LnGam(a);
 if (ax<-MAXLOG) then begin MathError( UNDERFLOW, 'igamc'); igamc:=0.0; exit end;
 ax:=Exp(ax);
{ continued fraction }
 y:=1.0-a; z:=x+y+1.0; c:=0.0; pkm2:=1.0; qkm2:=x; pkm1:=x+1.0;
 qkm1:=z*x; ans:=pkm1/qkm1;
 Repeat
  c:=c+1.0; y:=y+1.0; z:=z+2.0; yc:=y*c; pk:=(pkm1*z)-(pkm2*yc);
  qk:=(qkm1*z)-(qkm2*yc);
  if qk<>0 then begin r:=pk/qk; t:=Abs((ans-r)/r); ans:=r; end
   else t:=1.0;
  pkm2:=pkm1; pkm1:=pk; qkm2:=qkm1; qkm1:=qk;
  if Abs(pk)>big then
   begin
    pkm2:=pkm2*biginv; pkm1:=pkm1*biginv;
    qkm2:=qkm2*biginv; qkm1:=qkm1*biginv;
   end;
 until t<=MathEps;
 Result:=(ans*ax);
end;

function IGam(a, x:Double):Double;
var ans, ax, c, r:Double;
begin
 if (x<=0)or(a<=0) then begin igam:=0.0; Exit; end;
 if (x>1.0)and(x>a) then begin igam:=(1.0-igamc(a, x)); Exit; end;
 ax:=(a*Ln(x))-x-LnGam(a);
 if ax<-MAXLOG then begin MathError(UNDERFLOW,'igam'); igam:=0; Exit;end;
 ax:=Exp(ax);
 r:=a; c:=1.0; ans:=1.0;
 repeat
  r:=r+1.0; c:=c*x/r; ans:=ans+c;
 until (c/ans<=MathEps);
 IGam:=(ans*ax/a);
end;

function IGamI(a:Double; y0:Double):Double;
var x0, x1, x, yl, yh, y, d, lgm, dithresh:Double;
    i:Integer;
    dir:Integer;
begin
 x0:=MaxDouble; yl:=0.0; x1:=0.0; yh:=1.0; dithresh:=5.0*MathEps;
{approximation to inverse function }
 d:=1.0/(9.0*a); y:=(1.0-d-(ndtri(y0)*Sqrt(d))); x:=a*y*y*y;
 lgm:=LnGam(a);
 i:=0;
 While (i<10) Do
  begin
   if ((x>x0) Or (x<x1)) then begin d:=0.0625; Break; end;
   y:=igamc(a, x);
   if ((y<yl) Or (y>yh)) then begin d:=0.0625; Break; end;
   if (y<y0) then begin x0:=x; yl:=y; end
    else begin x1:=x; yh:=y; end;
   {compute the derivative of the function at this point }
   d:=(a-1.0)*Ln(x)-x-lgm;
   if d<-MAXLOG then begin d:=0.0625; Break; end;
   d:=-Exp(d);
  { compute the step to the next approximation of x }
   d:=(y-y0)/d;
   if (Abs(d/x)<MathEps) then begin IGamI:=x; Exit; end;
   x:=x-d;
   i:=Succ(i)
  end;
{ Resort to interval halving if Newton iteration did not converge. }
 if (x0=MaxDouble) then
  begin
   if (x<=0.0) then x:=1.0;
   while x0=MaxDouble do
    begin
     x:=(1.0+d)*x; y:=igamc(a, x);
     if y<y0 then begin x0:=x; yl:=y; Break; end;
     d:=d+d;
    end;
  end;
 d:=0.5; dir:=0; i:=0;
 while i<400 do
  begin
   x:=x1+(d*(x0-x1)); y:=igamc(a, x); lgm:=(x0-x1)/(x1+x0);
   if (Abs(lgm)<dithresh) then Break;
   lgm:=(y-y0)/y0;
   if Abs(lgm)<dithresh then Break;
   if x<=0.0 then Break;
   if y>=y0 then
   begin
    x1:=x; yh:=y;
    if (dir<0) then begin dir:=0; d:=0.5; end
    else
    begin
     if (dir>1) then d:=(0.5*d)+0.5 else d:=(y0-yl)/(yh-yl);
    end;
    dir:=dir+1;
   end
   else
   begin
    x0:=x; yl:=y;
    if (dir>0) then begin dir:=0; d:=0.5; end
    else
    begin
     if (dir<-1) then d:=0.5*d else d:=(y0-yl)/(yh-yl);
    end;
    dir:=dir-1;
   end;
   i:=Succ(i)
  end;
 if x=0.0 then MathError(UNDERFLOW,'igami');
 IGamI:=(x);
end;

end.
